## passt 0.0~git20230216.4663ccc

=== Makefile ===
# SPDX-License-Identifier: AGPL-3.0-or-later
#
# PASST - Plug A Simple Socket Transport
#  for qemu/UNIX domain socket mode
#
# PASTA - Pack A Subtle Tap Abstraction
#  for network namespace/tap device mode
#
# Copyright (c) 2021 Red Hat GmbH
# Author: Stefano Brivio <sbrivio@redhat.com>

VERSION ?= $(shell git describe --tags HEAD 2>/dev/null || echo "unknown\ version")

# Does the target platform allow IPv4 connections to be handled via
# the IPv6 socket API? (Linux does)
DUAL_STACK_SOCKETS := 1

RLIMIT_STACK_VAL := $(shell /bin/sh -c 'ulimit -s')
ifeq ($(RLIMIT_STACK_VAL),unlimited)
RLIMIT_STACK_VAL := 1024
endif

TARGET := $(shell $(CC) -dumpmachine)
# Get 'uname -m'-like architecture description for target
TARGET_ARCH := $(shell echo $(TARGET) | cut -f1 -d- | tr [A-Z] [a-z])
TARGET_ARCH := $(shell echo $(TARGET_ARCH) | sed 's/powerpc/ppc/')

AUDIT_ARCH := $(shell echo $(TARGET_ARCH) | tr [a-z] [A-Z] | sed 's/^ARM.*/ARM/')
AUDIT_ARCH := $(shell echo $(AUDIT_ARCH) | sed 's/I[456]86/I386/')
AUDIT_ARCH := $(shell echo $(AUDIT_ARCH) | sed 's/PPC64/PPC/')
AUDIT_ARCH := $(shell echo $(AUDIT_ARCH) | sed 's/PPCLE/PPC64LE/')
AUDIT_ARCH := $(shell echo $(AUDIT_ARCH) | sed 's/MIPS64EL/MIPSEL64/')
AUDIT_ARCH := $(shell echo $(AUDIT_ARCH) | sed 's/HPPA/PARISC/')

FLAGS := -Wall -Wextra -pedantic -std=c99 -D_XOPEN_SOURCE=700 -D_GNU_SOURCE
FLAGS += -D_FORTIFY_SOURCE=2 -O2 -pie -fPIE
FLAGS += -DPAGE_SIZE=$(shell getconf PAGE_SIZE)
FLAGS += -DNETNS_RUN_DIR=\"/run/netns\"
FLAGS += -DPASST_AUDIT_ARCH=AUDIT_ARCH_$(AUDIT_ARCH)
FLAGS += -DRLIMIT_STACK_VAL=$(RLIMIT_STACK_VAL)
FLAGS += -DARCH=\"$(TARGET_ARCH)\"
FLAGS += -DVERSION=\"$(VERSION)\"
FLAGS += -DDUAL_STACK_SOCKETS=$(DUAL_STACK_SOCKETS)

PASST_SRCS = arch.c arp.c checksum.c conf.c dhcp.c dhcpv6.c icmp.c igmp.c \
	isolation.c lineread.c log.c mld.c ndp.c netlink.c packet.c passt.c \
	pasta.c pcap.c siphash.c tap.c tcp.c tcp_splice.c udp.c util.c
QRAP_SRCS = qrap.c
SRCS = $(PASST_SRCS) $(QRAP_SRCS)

MANPAGES = passt.1 pasta.1 qrap.1

PASST_HEADERS = arch.h arp.h checksum.h conf.h dhcp.h dhcpv6.h icmp.h \
	inany.h isolation.h lineread.h log.h ndp.h netlink.h packet.h passt.h \
	pasta.h pcap.h port_fwd.h siphash.h tap.h tcp.h tcp_conn.h \
	tcp_splice.h udp.h util.h
HEADERS = $(PASST_HEADERS) seccomp.h

# On gcc 11 and 12, with -O2 and -flto, tcp_hash() and siphash_20b(), if
# inlined, seem to be hitting something similar to:
#	https://gcc.gnu.org/bugzilla/show_bug.cgi?id=78993
# from the pointer arithmetic used from the tcp_tap_handler() path to get the
# remote connection address.
#
# TODO: With the same combination, in ndp(), gcc optimises away the store of
# hop_limit in the IPv6 header (temporarily set to the protocol number for
# convenience, to mimic the ICMPv6 checksum pseudo-header) before the call to
# csum_unaligned(). Mark csum_unaligned() as "noipa" as a quick work-around,
# while we figure out if a corresponding gcc issue has already been reported.
ifeq (,$(filter-out 11 12, $(shell $(CC) -dumpversion)))
ifneq (,$(filter -flto%,$(FLAGS) $(CFLAGS) $(CPPFLAGS)))
ifneq (,$(filter -O2,$(FLAGS) $(CFLAGS) $(CPPFLAGS)))
	FLAGS += -DTCP_HASH_NOINLINE
	FLAGS += -DSIPHASH_20B_NOINLINE
	FLAGS += -DCSUM_UNALIGNED_NO_IPA
endif
endif
endif

C := \#include <linux/tcp.h>\nstruct tcp_info x = { .tcpi_snd_wnd = 0 };
ifeq ($(shell printf "$(C)" | $(CC) -S -xc - -o - >/dev/null 2>&1; echo $$?),0)
	FLAGS += -DHAS_SND_WND
endif

C := \#include <linux/tcp.h>\nstruct tcp_info x = { .tcpi_bytes_acked = 0 };
ifeq ($(shell printf "$(C)" | $(CC) -S -xc - -o - >/dev/null 2>&1; echo $$?),0)
	FLAGS += -DHAS_BYTES_ACKED
endif

C := \#include <linux/tcp.h>\nstruct tcp_info x = { .tcpi_min_rtt = 0 };
ifeq ($(shell printf "$(C)" | $(CC) -S -xc - -o - >/dev/null 2>&1; echo $$?),0)
	FLAGS += -DHAS_MIN_RTT
endif

C := \#include <sys/random.h>\nint main(){int a=getrandom(0, 0, 0);}
ifeq ($(shell printf "$(C)" | $(CC) -S -xc - -o - >/dev/null 2>&1; echo $$?),0)
	FLAGS += -DHAS_GETRANDOM
endif

ifeq ($(shell :|$(CC) -fstack-protector-strong -S -xc - -o - >/dev/null 2>&1; echo $$?),0)
	FLAGS += -fstack-protector-strong
endif

C := \#define _GNU_SOURCE\n\#include <fcntl.h>\nint x = FALLOC_FL_COLLAPSE_RANGE;
ifeq ($(shell printf "$(C)" | $(CC) -S -xc - -o - >/dev/null 2>&1; echo $$?),0)
	EXTRA_SYSCALLS += fallocate
endif

prefix		?= /usr/local
exec_prefix	?= $(prefix)
bindir		?= $(exec_prefix)/bin
datarootdir	?= $(prefix)/share
docdir		?= $(datarootdir)/doc/passt
mandir		?= $(datarootdir)/man
man1dir		?= $(mandir)/man1

ifeq ($(TARGET_ARCH),x86_64)
BIN := passt passt.avx2 pasta pasta.avx2 qrap
else
BIN := passt pasta qrap
endif

all: $(BIN) $(MANPAGES) docs

static: FLAGS += -static -DGLIBC_NO_STATIC_NSS
static: clean all

seccomp.h: seccomp.sh $(PASST_SRCS) $(PASST_HEADERS)
	@ EXTRA_SYSCALLS="$(EXTRA_SYSCALLS)" ./seccomp.sh $(PASST_SRCS) $(PASST_HEADERS)

passt: $(PASST_SRCS) $(HEADERS)
	$(CC) $(FLAGS) $(CFLAGS) $(CPPFLAGS) $(PASST_SRCS) -o passt $(LDFLAGS)

passt.avx2: FLAGS += -Ofast -mavx2 -ftree-vectorize -funroll-loops
passt.avx2: $(PASST_SRCS) $(HEADERS)
	$(CC) $(filter-out -O2,$(FLAGS)) $(CFLAGS) $(CPPFLAGS) \
		$(PASST_SRCS) -o passt.avx2 $(LDFLAGS)

passt.avx2: passt

pasta.avx2 pasta.1 pasta: pasta%: passt%
	ln -sf $< $@

qrap: $(QRAP_SRCS) passt.h
	$(CC) $(FLAGS) $(CFLAGS) $(CPPFLAGS) $(QRAP_SRCS) -o qrap $(LDFLAGS)

valgrind: EXTRA_SYSCALLS += rt_sigprocmask rt_sigtimedwait rt_sigaction	\
			    getpid gettid kill clock_gettime mmap	\
			    munmap open unlink gettimeofday futex
valgrind: FLAGS:=-g -O0 $(filter-out -O%,$(FLAGS))
valgrind: all

.PHONY: clean
clean:
	$(RM) $(BIN) *~ *.o seccomp.h pasta.1 \
		passt.tar passt.tar.gz *.deb *.rpm \
		passt.pid README.plain.md

install: $(BIN) $(MANPAGES) docs
	mkdir -p $(DESTDIR)$(bindir) $(DESTDIR)$(man1dir)
	cp -d $(BIN) $(DESTDIR)$(bindir)
	cp -d $(MANPAGES) $(DESTDIR)$(man1dir)
	mkdir -p $(DESTDIR)$(docdir)
	cp -d README.plain.md $(DESTDIR)$(docdir)/README.md
	cp -d doc/demo.sh $(DESTDIR)$(docdir)

uninstall:
	$(RM) $(BIN:%=$(DESTDIR)$(prefix)/bin/%)
	$(RM) $(MANPAGES:%=$(DESTDIR)$(man1dir)/%)
	$(RM) $(DESTDIR)$(docdir)/README.md
	$(RM) $(DESTDIR)$(docdir)/demo.sh
	-rmdir $(DESTDIR)$(docdir)

pkgs: static
	tar cf passt.tar -P --xform 's//\/usr\/bin\//' $(BIN)
	tar rf passt.tar -P --xform 's//\/usr\/share\/man\/man1\//' \
		$(MANPAGES)
	gzip passt.tar
	EMAIL="sbrivio@redhat.com" fakeroot alien --to-deb \
		--description="User-mode networking for VMs and namespaces" \
		-k --version=$(shell git rev-parse --short HEAD) \
		passt.tar.gz
	fakeroot alien --to-rpm --target=$(shell uname -m) \
		--description="User-mode networking for VMs and namespaces" \
		-k --version=g$(shell git rev-parse --short HEAD) passt.tar.gz

# TODO: This hack makes a "plain" Markdown version of README.md that can be
# reasonably shipped as documentation file, while the current README.md is
# definitely intended for web browser consumption. It should probably work the
# other way around: the web version should be obtained by adding HTML and
# JavaScript portions to a plain Markdown, instead. However, cgit needs to use
# a file in the git tree. Find a better way around this.
docs: README.md
	@(								\
		skip=0;							\
		while read l; do					\
			case $$l in					\
			"## Demo")	exit 0		;;		\
			"<!"*)				;;		\
			"</"*)		skip=1		;;		\
			"<"*)		skip=2		;;		\
			esac;						\
									\
			[ $$skip -eq 0 ]	&& echo "$$l";		\
			[ $$skip -eq 1 ]	&& skip=0;		\
		done < README.md;					\
	) > README.plain.md

# Checkers currently disabled for clang-tidy:
# - llvmlibc-restrict-system-libc-headers
#	TODO: this is Linux-only for the moment, nice to fix eventually
#
# - bugprone-macro-parentheses
# - google-readability-braces-around-statements
# - hicpp-braces-around-statements
# - readability-braces-around-statements
#	Debatable whether that improves readability, right now it would look
#	like a mess
#
# - readability-magic-numbers
# - cppcoreguidelines-avoid-magic-numbers
#	TODO: in most cases they are justified, but probably not everywhere
#
# - clang-analyzer-valist.Uninitialized
#	TODO: enable once https://bugs.llvm.org/show_bug.cgi?id=41311 is fixed
#
# - clang-analyzer-security.insecureAPI.DeprecatedOrUnsafeBufferHandling
#	Probably not doable to impement this without plain memcpy(), memset()
#
# - cppcoreguidelines-init-variables
#	Dubious value, would kill readability
#
# - hicpp-signed-bitwise
#	Those are needed for syscalls, epoll_wait flags, etc.
#
# - llvm-include-order
#	TODO: not really important, but nice to fix eventually
#
# - readability-isolate-declaration
#	Dubious value, would kill readability
#
# - bugprone-narrowing-conversions
# - cppcoreguidelines-narrowing-conversions
#	TODO: nice to fix eventually
#
# - cppcoreguidelines-avoid-non-const-global-variables
#	TODO: check, fix, and more in general constify wherever possible
#
# - altera-unroll-loops
# - altera-id-dependent-backward-branch
#	TODO: check paths where it might make sense to improve performance
#
# - bugprone-easily-swappable-parameters
#	Not much can be done about them other than being careful
#
# - readability-function-cognitive-complexity
#	TODO: split reported functions
#
# - altera-struct-pack-align
#	"Poor" alignment needed for structs reflecting message formats/headers
#
# - concurrency-mt-unsafe
#	TODO: check again if multithreading is implemented
#
# - readability-identifier-length
#	Complains about any identifier <3 characters, reasonable for
#	globals, pointlessly verbose for locals and parameters.
#
# - bugprone-assignment-in-if-condition
#	Dubious value over the compiler's built-in warning.  Would
#	increase verbosity.

clang-tidy: $(SRCS) $(HEADERS)
	clang-tidy -checks=*,-modernize-*,\
	-clang-analyzer-valist.Uninitialized,\
	-cppcoreguidelines-init-variables,\
	-bugprone-assignment-in-if-condition,\
	-bugprone-macro-parentheses,\
	-google-readability-braces-around-statements,\
	-hicpp-braces-around-statements,\
	-readability-braces-around-statements,\
	-readability-magic-numbers,\
	-llvmlibc-restrict-system-libc-headers,\
	-hicpp-signed-bitwise,\
	-clang-analyzer-security.insecureAPI.DeprecatedOrUnsafeBufferHandling,\
	-llvm-include-order,\
	-cppcoreguidelines-avoid-magic-numbers,\
	-readability-isolate-declaration,\
	-bugprone-narrowing-conversions,\
	-cppcoreguidelines-narrowing-conversions,\
	-cppcoreguidelines-avoid-non-const-global-variables,\
	-altera-unroll-loops,-altera-id-dependent-backward-branch,\
	-bugprone-easily-swappable-parameters,\
	-readability-function-cognitive-complexity,\
	-altera-struct-pack-align,\
	-concurrency-mt-unsafe,\
	-readability-identifier-length \
	-config='{CheckOptions: [{key: bugprone-suspicious-string-compare.WarnOnImplicitComparison, value: "false"}]}' \
	--warnings-as-errors=* $(SRCS) -- $(filter-out -pie,$(FLAGS) $(CFLAGS) $(CPPFLAGS))

SYSTEM_INCLUDES := /usr/include $(wildcard /usr/include/$(TARGET))
ifeq ($(shell $(CC) -v 2>&1 | grep -c "gcc version"),1)
VER := $(shell $(CC) -dumpversion)
SYSTEM_INCLUDES += /usr/lib/gcc/$(TARGET)/$(VER)/include
endif
cppcheck: $(SRCS) $(HEADERS)
	cppcheck --std=c99 --error-exitcode=1 --enable=all --force	\
	--inconclusive --library=posix --quiet				\
	$(SYSTEM_INCLUDES:%=-I%)					\
	$(SYSTEM_INCLUDES:%=--config-exclude=%)				\
	$(SYSTEM_INCLUDES:%=--suppress=*:%/*)				\
	$(SYSTEM_INCLUDES:%=--suppress=unmatchedSuppression:%/*)	\
	--inline-suppr							\
	--suppress=unusedStructMember					\
	$(filter -D%,$(FLAGS) $(CFLAGS) $(CPPFLAGS))			\
	.

=== debian/changelog ===
passt (0.0~git20230216.4663ccc-1) unstable; urgency=medium

  * New upstream version 0.0~git20230216.4663ccc

 -- Stefano Brivio <sbrivio@redhat.com>  Fri, 17 Feb 2023 12:48:47 +0100

passt (0.0~git20221116.ace074c-1) unstable; urgency=medium

  * New upstream version 0.0~git20221116.ace074c. Most relevant
    change: AppArmor profile actually covers both pasta(1) and
    passt(1)
  * Fix Vcs-Browser and Vcs-Git links in debian/control
  * Build with -DVERSION corresponding to current package version
  * Move copy of AppArmor profile to debian/passt.install

 -- Stefano Brivio <sbrivio@redhat.com>  Wed, 16 Nov 2022 22:42:50 +0100

passt (0.0~git20221104.e308018-1) unstable; urgency=medium

  * Initial release. Closes: #1010498

 -- Stefano Brivio <sbrivio@redhat.com>  Fri, 04 Nov 2022 18:26:31 +0100

=== debian/control ===
Source: passt
Section: net
Priority: optional
Maintainer: Stefano Brivio <sbrivio@redhat.com>
Build-Depends: debhelper-compat (= 13), dh-apparmor
Rules-Requires-Root: no
Standards-Version: 4.6.1.0
Homepage: https://passt.top/
Vcs-Browser: https://salsa.debian.org/sbrivio/passt
Vcs-Git: https://salsa.debian.org/sbrivio/passt.git

Package: passt
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: apparmor
Description: user-mode networking daemons for virtual machines and namespaces
 passt implements a translation layer between a Layer-2 network interface and
 native Layer-4 sockets (TCP, UDP, ICMP/ICMPv6 echo) on a host. It doesn't
 require any capabilities or privileges, and it can be used as a simple
 replacement for Slirp.
 .
 pasta (same binary as passt, different command) offers equivalent
 functionality, for network namespaces: traffic is forwarded using a tap
 interface inside the namespace, without the need to create further interfaces
 on the host, hence not requiring any capabilities or privileges.

## passt 0.0~git20230309.7c7625d

=== Makefile ===
--- 
+++ 
@@ -31,6 +31,7 @@
 AUDIT_ARCH := $(shell echo $(AUDIT_ARCH) | sed 's/PPCLE/PPC64LE/')
 AUDIT_ARCH := $(shell echo $(AUDIT_ARCH) | sed 's/MIPS64EL/MIPSEL64/')
 AUDIT_ARCH := $(shell echo $(AUDIT_ARCH) | sed 's/HPPA/PARISC/')
+AUDIT_ARCH := $(shell echo $(AUDIT_ARCH) | sed 's/SH4/SH/')
 
 FLAGS := -Wall -Wextra -pedantic -std=c99 -D_XOPEN_SOURCE=700 -D_GNU_SOURCE
 FLAGS += -D_FORTIFY_SOURCE=2 -O2 -pie -fPIE
@@ -56,27 +57,6 @@
 	tcp_splice.h udp.h util.h
 HEADERS = $(PASST_HEADERS) seccomp.h
 
-# On gcc 11 and 12, with -O2 and -flto, tcp_hash() and siphash_20b(), if
-# inlined, seem to be hitting something similar to:
-#	https://gcc.gnu.org/bugzilla/show_bug.cgi?id=78993
-# from the pointer arithmetic used from the tcp_tap_handler() path to get the
-# remote connection address.
-#
-# TODO: With the same combination, in ndp(), gcc optimises away the store of
-# hop_limit in the IPv6 header (temporarily set to the protocol number for
-# convenience, to mimic the ICMPv6 checksum pseudo-header) before the call to
-# csum_unaligned(). Mark csum_unaligned() as "noipa" as a quick work-around,
-# while we figure out if a corresponding gcc issue has already been reported.
-ifeq (,$(filter-out 11 12, $(shell $(CC) -dumpversion)))
-ifneq (,$(filter -flto%,$(FLAGS) $(CFLAGS) $(CPPFLAGS)))
-ifneq (,$(filter -O2,$(FLAGS) $(CFLAGS) $(CPPFLAGS)))
-	FLAGS += -DTCP_HASH_NOINLINE
-	FLAGS += -DSIPHASH_20B_NOINLINE
-	FLAGS += -DCSUM_UNALIGNED_NO_IPA
-endif
-endif
-endif
-
 C := \#include <linux/tcp.h>\nstruct tcp_info x = { .tcpi_snd_wnd = 0 };
 ifeq ($(shell printf "$(C)" | $(CC) -S -xc - -o - >/dev/null 2>&1; echo $$?),0)
 	FLAGS += -DHAS_SND_WND
@@ -126,7 +106,7 @@
 static: clean all
 
 seccomp.h: seccomp.sh $(PASST_SRCS) $(PASST_HEADERS)
-	@ EXTRA_SYSCALLS="$(EXTRA_SYSCALLS)" ./seccomp.sh $(PASST_SRCS) $(PASST_HEADERS)
+	@ EXTRA_SYSCALLS="$(EXTRA_SYSCALLS)" ARCH="$(TARGET_ARCH)" CC="$(CC)" ./seccomp.sh $(PASST_SRCS) $(PASST_HEADERS)
 
 passt: $(PASST_SRCS) $(HEADERS)
 	$(CC) $(FLAGS) $(CFLAGS) $(CPPFLAGS) $(PASST_SRCS) -o passt $(LDFLAGS)

=== test/Makefile ===
# SPDX-License-Identifier: AGPL-3.0-or-later
#
# Tests makefile
#
# Copyright Red Hat
# Author: David Gibson <david@gibson.dropbear.id.au>

WGET = wget -c

DEBIAN_IMGS = debian-8.11.0-openstack-amd64.qcow2 \
	debian-9-nocloud-amd64-daily-20200210-166.qcow2 \
	debian-10-nocloud-amd64.qcow2 \
	debian-10-generic-arm64.qcow2 \
	debian-10-generic-ppc64el-20220911-1135.qcow2 \
	debian-11-nocloud-amd64.qcow2 \
	debian-11-generic-arm64.qcow2 \
	debian-11-generic-ppc64el.qcow2 \
	debian-sid-nocloud-amd64-daily.qcow2 \
	debian-sid-nocloud-arm64-daily.qcow2 \
	debian-sid-nocloud-ppc64el-daily.qcow2

FEDORA_IMGS = Fedora-Cloud-Base-26-1.5.x86_64.qcow2 \
	Fedora-Cloud-Base-27-1.6.x86_64.qcow2 \
	Fedora-Cloud-Base-28-1.1.x86_64.qcow2 \
	Fedora-Cloud-Base-28-1.1.aarch64.qcow2 \
	Fedora-Cloud-Base-29-1.2.x86_64.qcow2 \
	Fedora-Cloud-Base-29-1.2.aarch64.qcow2 \
	Fedora-Cloud-Base-30-1.2.x86_64.qcow2 \
	Fedora-Cloud-Base-30-1.2.aarch64.qcow2 \
	Fedora-Cloud-Base-31-1.9.x86_64.qcow2 \
	Fedora-Cloud-Base-31-1.9.aarch64.qcow2 \
	Fedora-Cloud-Base-32-1.6.x86_64.qcow2 \
	Fedora-Cloud-Base-32-1.6.aarch64.qcow2 \
	Fedora-Cloud-Base-33-1.2.x86_64.qcow2 \
	Fedora-Cloud-Base-33-1.2.aarch64.qcow2 \
	Fedora-Cloud-Base-34-1.2.x86_64.qcow2 \
	Fedora-Cloud-Base-34-1.2.aarch64.qcow2 \
	Fedora-Cloud-Base-35-1.2.x86_64.qcow2 \
	Fedora-Cloud-Base-35-1.2.aarch64.qcow2

OPENSUSE_IMGS = openSUSE-Leap-15.1-JeOS.x86_64-kvm-and-xen.qcow2 \
	openSUSE-Leap-15.2-JeOS.x86_64-kvm-and-xen.qcow2 \
	openSUSE-Leap-15.3-JeOS.x86_64-kvm-and-xen.qcow2 \
	openSUSE-Tumbleweed-ARM-JeOS-efi.aarch64.raw.xz \
	openSUSE-Tumbleweed-ARM-JeOS-efi.armv7l.raw.xz \
	openSUSE-Tumbleweed-JeOS.x86_64-kvm-and-xen.qcow2

UBUNTU_OLD_IMGS = trusty-server-cloudimg-amd64-disk1.img \
	trusty-server-cloudimg-i386-disk1.img \
	trusty-server-cloudimg-ppc64el-disk1.img
UBUNTU_NEW_IMGS = xenial-server-cloudimg-powerpc-disk1.img \
	jammy-server-cloudimg-s390x.img
UBUNTU_IMGS = $(UBUNTU_OLD_IMGS) $(UBUNTU_NEW_IMGS)

DOWNLOAD_ASSETS = mbuto \
	$(DEBIAN_IMGS) $(FEDORA_IMGS) $(OPENSUSE_IMGS) $(UBUNTU_IMGS)
TESTDATA_ASSETS = small.bin big.bin medium.bin
LOCAL_ASSETS = mbuto.img mbuto.mem.img QEMU_EFI.fd \
	$(DEBIAN_IMGS:%=prepared-%) $(FEDORA_IMGS:%=prepared-%) \
	$(UBUNTU_NEW_IMGS:%=prepared-%) \
	nsholder guest-key guest-key.pub \
	$(TESTDATA_ASSETS)

ASSETS = $(DOWNLOAD_ASSETS) $(LOCAL_ASSETS)

CFLAGS = -Wall -Werror -Wextra -pedantic -std=c99

assets: $(ASSETS)

mbuto:
	git clone git://mbuto.sh/mbuto

guest-key guest-key.pub:
	ssh-keygen -f guest-key -N ''

mbuto.img: passt.mbuto mbuto guest-key.pub $(TESTDATA_ASSETS)
	./mbuto/mbuto -p ./$< -c lz4 -f $@

mbuto.mem.img: passt.mem.mbuto mbuto ../passt.avx2
	./mbuto/mbuto -p ./$< -c lz4 -f $@

nsholder: nsholder.c
	$(CC) $(CFLAGS) -o $@ $^

QEMU_EFI.fd:
	./find-arm64-firmware.sh $@

prepared-%.qcow2: %.qcow2 ./prepare-distro-img.sh
	qemu-img create -f qcow2 -F qcow2 -b $< $@
	./prepare-distro-img.sh $@

prepared-%.img: %.img ./prepare-distro-img.sh
	qemu-img create -f qcow2 -F qcow2 -b $< $@
	./prepare-distro-img.sh $(IMGTYPE) $@

small.bin:
	dd if=/dev/urandom bs=2k count=1 of=$@

medium.bin:
	dd if=/dev/urandom bs=1k count=5 of=$@

big.bin:
	dd if=/dev/urandom bs=1M count=10 of=$@

check: assets
	./run

debug: assets
	DEBUG=1 ./run

clean:
	rm -f perf.js *~
	rm -f $(LOCAL_ASSETS)
	rm -rf test_logs
	rm -f prepared-*.qcow2 prepared-*.img

realclean: clean
	rm -rf $(DOWNLOAD_ASSETS)

# Debian downloads
debian-8.11.0-openstack-%.qcow2:
	$(WGET) -O $@ https://cloud.debian.org/images/cloud/OpenStack/archive/8.11.0/debian-8.11.0-openstack-$*.qcow2

debian-9-nocloud-%-daily-20200210-166.qcow2:
	$(WGET) -O $@ https://cloud.debian.org/images/cloud/stretch/daily/20200210-166/debian-9-nocloud-$*-daily-20200210-166.qcow2

debian-10-nocloud-%.qcow2:
	$(WGET) -O $@ https://cloud.debian.org/images/cloud/buster/latest/debian-10-nocloud-$*.qcow2

debian-10-generic-ppc64el-20220911-1135.qcow2:
	$(WGET) -O $@ https://cloud.debian.org/images/cloud/buster/20220911-1135/debian-10-generic-ppc64el-20220911-1135.qcow2

debian-10-generic-%.qcow2:
	$(WGET) -O $@ https://cloud.debian.org/images/cloud/buster/latest/debian-10-generic-$*.qcow2

debian-11-nocloud-%.qcow2:
	$(WGET) -O $@ https://cloud.debian.org/images/cloud/bullseye/latest/debian-11-nocloud-$*.qcow2

debian-11-generic-%.qcow2:
	$(WGET) -O $@ https://cloud.debian.org/images/cloud/bullseye/latest/debian-11-generic-$*.qcow2

debian-sid-nocloud-%-daily.qcow2:
	$(WGET) -O $@ https://cloud.debian.org/images/cloud/sid/daily/latest/debian-sid-nocloud-$*-daily.qcow2

# Fedora downloads
Fedora-Cloud-Base-26-1.5.%.qcow2:
	$(WGET) -O $@ http://archives.fedoraproject.org/pub/archive/fedora/linux/releases/26/CloudImages/$*/images/Fedora-Cloud-Base-26-1.5.$*.qcow2

Fedora-Cloud-Base-27-1.6.%.qcow2:
	$(WGET) -O $@ http://archives.fedoraproject.org/pub/archive/fedora/linux/releases/27/CloudImages/$*/images/Fedora-Cloud-Base-27-1.6.$*.qcow2

Fedora-Cloud-Base-28-1.1.%.qcow2:
	$(WGET) -O $@ http://archives.fedoraproject.org/pub/archive/fedora/linux/releases/28/Cloud/$*/images/Fedora-Cloud-Base-28-1.1.$*.qcow2

Fedora-Cloud-Base-29-1.2.%.qcow2:
	$(WGET) -O $@ http://archives.fedoraproject.org/pub/archive/fedora/linux/releases/29/Cloud/$*/images/Fedora-Cloud-Base-29-1.2.$*.qcow2

Fedora-Cloud-Base-30-1.2.%.qcow2:
	$(WGET) -O $@ http://archives.fedoraproject.org/pub/archive/fedora/linux/releases/30/Cloud/$*/images/Fedora-Cloud-Base-30-1.2.$*.qcow2

Fedora-Cloud-Base-31-1.9.%.qcow2:
	$(WGET) -O $@ http://archives.fedoraproject.org/pub/archive/fedora/linux/releases/31/Cloud/$*/images/Fedora-Cloud-Base-31-1.9.$*.qcow2

Fedora-Cloud-Base-32-1.6.%.qcow2:
	$(WGET) -O $@ https://archives.fedoraproject.org/pub/archive/fedora/linux/releases/32/Cloud/$*/images/Fedora-Cloud-Base-32-1.6.$*.qcow2

Fedora-Cloud-Base-33-1.2.%.qcow2:
	$(WGET) -O $@ https://archives.fedoraproject.org/pub/archive/fedora/linux/releases/33/Cloud/$*/images/Fedora-Cloud-Base-33-1.2.$*.qcow2

Fedora-Cloud-Base-34-1.2.%.qcow2:
	$(WGET) -O $@ https://archives.fedoraproject.org/pub/archive/fedora/linux/releases/34/Cloud/$*/images/Fedora-Cloud-Base-34-1.2.$*.qcow2

Fedora-Cloud-Base-35-1.2.%.qcow2:
	$(WGET) -O $@ https://archives.fedoraproject.org/pub/archive/fedora/linux/releases/35/Cloud/$*/images/Fedora-Cloud-Base-35-1.2.$*.qcow2

# OpenSuSE downloads
openSUSE-Leap-15.1-JeOS.x86_64-kvm-and-xen.qcow2:
	$(WGET) -O $@ https://download.opensuse.org/distribution/leap/15.1/jeos/openSUSE-Leap-15.1-JeOS.x86_64-kvm-and-xen.qcow2

openSUSE-Leap-15.2-JeOS.x86_64-kvm-and-xen.qcow2:
	$(WGET) -O $@ https://download.opensuse.org/distribution/leap/15.2/appliances/openSUSE-Leap-15.2-JeOS.x86_64-kvm-and-xen.qcow2

openSUSE-Leap-15.3-JeOS.x86_64-kvm-and-xen.qcow2:
	$(WGET) -O $@ https://download.opensuse.org/distribution/leap/15.3/appliances/openSUSE-Leap-15.3-JeOS.x86_64-kvm-and-xen.qcow2

openSUSE-Tumbleweed-ARM-JeOS-efi.aarch64.raw.xz:
	$(WGET) -O $@ http://download.opensuse.org/ports/aarch64/tumbleweed/appliances/openSUSE-Tumbleweed-ARM-JeOS-efi.aarch64.raw.xz

openSUSE-Tumbleweed-ARM-JeOS-efi.armv7l.raw.xz:
	$(WGET) -O $@ http://download.opensuse.org/ports/armv7hl/tumbleweed/appliances/openSUSE-Tumbleweed-ARM-JeOS-efi.armv7l.raw.xz

openSUSE-Tumbleweed-JeOS.x86_64-kvm-and-xen.qcow2:
	$(WGET) -O $@ https://download.opensuse.org/tumbleweed/appliances/openSUSE-Tumbleweed-JeOS.x86_64-kvm-and-xen.qcow2

# Ubuntu downloads
trusty-server-cloudimg-%-disk1.img:
	$(WGET) -O $@ https://cloud-images.ubuntu.com/trusty/current/trusty-server-cloudimg-$*-disk1.img

xenial-server-cloudimg-powerpc-disk1.img:
	$(WGET) -O $@ https://cloud-images.ubuntu.com/xenial/current/xenial-server-cloudimg-powerpc-disk1.img

jammy-server-cloudimg-s390x.img:
	$(WGET) -O $@ https://cloud-images.ubuntu.com/jammy/current/jammy-server-cloudimg-s390x.img

=== debian/changelog ===
passt (0.0~git20230309.7c7625d-1) unstable; urgency=medium

  * New upstream version 0.0~git20230309.7c7625d
  * Fix cross-build and armhf build reproducibility by using the
    target declared by the compiler to build seccomp profiles, not
    the current machine type
  * Fix build on sh4 by correcting the AUDIT_ARCH target name
  * Fix signedness warning reported on 32-bit architectures
  * Terminate gracefully if open files quota is reached
  * Fix inbound TCP Maximum Segment Size used to queue data to tap
    interface, in pasta mode
  * Fix accidental gap in slirp4netns compatibility by introducing
    trivial options to actually set outbound interfaces and addresses

 -- Stefano Brivio <sbrivio@redhat.com>  Thu, 09 Mar 2023 09:29:19 +0100

passt (0.0~git20230227.c538ee8-1) unstable; urgency=medium

  * New upstream version 0.0~git20230227.c538ee8
  * Most rules from the AppArmor profile are now divided into two
    abstractions for passt(1) and pasta(1), and the usr.bin.passt
    profile sources them. This makes it easier for frameworks
    such as libvirt to source the required parts in subprofiles

 -- Stefano Brivio <sbrivio@redhat.com>  Mon, 27 Feb 2023 23:29:43 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Stefano Brivio <sbrivio@redhat.com>
 Build-Depends: debhelper-compat (= 13), dh-apparmor
 Rules-Requires-Root: no
-Standards-Version: 4.6.1.0
+Standards-Version: 4.6.2
 Homepage: https://passt.top/
 Vcs-Browser: https://salsa.debian.org/sbrivio/passt
 Vcs-Git: https://salsa.debian.org/sbrivio/passt.git

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_auto_install:
	dh_auto_install -- prefix=/usr
	dh_apparmor --profile-name=usr.bin.passt -ppasst

ifneq (,$(findstring amd64,$(DEB_BUILD_ARCH)))
override_dh_link:
	dh_link usr/share/man/man1/passt.1 usr/share/man/man1/passt.avx2.1
	dh_link usr/share/man/man1/pasta.1 usr/share/man/man1/pasta.avx2.1
endif

%:
	export VERSION="$(DEB_UPSTREAM_VERSION)"
	dh $@

## passt 0.0~git20230627.289301b

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# SPDX-License-Identifier: AGPL-3.0-or-later
+# SPDX-License-Identifier: GPL-2.0-or-later
 #
 # PASST - Plug A Simple Socket Transport
 #  for qemu/UNIX domain socket mode
@@ -20,7 +20,7 @@
 RLIMIT_STACK_VAL := 1024
 endif
 
-TARGET := $(shell $(CC) -dumpmachine)
+TARGET ?= $(shell $(CC) -dumpmachine)
 # Get 'uname -m'-like architecture description for target
 TARGET_ARCH := $(shell echo $(TARGET) | cut -f1 -d- | tr [A-Z] [a-z])
 TARGET_ARCH := $(shell echo $(TARGET_ARCH) | sed 's/powerpc/ppc/')

=== debian/changelog ===
passt (0.0~git20230627.289301b-1) unstable; urgency=medium

  * New upstream version 0.0~git20230627.289301b
  * Update licensing information to new licensing terms from upstream
    (GPLv2+ instead of AGPLv3+)
  * Fix cross-build in Debian package itself by overriding TARGET via
    dh_auto_install with target architecture

 -- Stefano Brivio <sbrivio@redhat.com>  Thu, 27 Mar 2023 19:31:18 +0200

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 override_dh_auto_install:
-	dh_auto_install -- prefix=/usr
+	dh_auto_install -- prefix=/usr TARGET=$(DEB_BUILD_ARCH)
 	dh_apparmor --profile-name=usr.bin.passt -ppasst
 
 ifneq (,$(findstring amd64,$(DEB_BUILD_ARCH)))

## passt 0.0~git20240220.1e6f92b

=== Makefile ===
--- 
+++ 
@@ -33,7 +33,8 @@
 AUDIT_ARCH := $(shell echo $(AUDIT_ARCH) | sed 's/HPPA/PARISC/')
 AUDIT_ARCH := $(shell echo $(AUDIT_ARCH) | sed 's/SH4/SH/')
 
-FLAGS := -Wall -Wextra -pedantic -std=c99 -D_XOPEN_SOURCE=700 -D_GNU_SOURCE
+FLAGS := -Wall -Wextra -Wno-format-zero-length
+FLAGS += -pedantic -std=c11 -D_XOPEN_SOURCE=700 -D_GNU_SOURCE
 FLAGS += -D_FORTIFY_SOURCE=2 -O2 -pie -fPIE
 FLAGS += -DPAGE_SIZE=$(shell getconf PAGE_SIZE)
 FLAGS += -DNETNS_RUN_DIR=\"/run/netns\"
@@ -43,18 +44,19 @@
 FLAGS += -DVERSION=\"$(VERSION)\"
 FLAGS += -DDUAL_STACK_SOCKETS=$(DUAL_STACK_SOCKETS)
 
-PASST_SRCS = arch.c arp.c checksum.c conf.c dhcp.c dhcpv6.c icmp.c igmp.c \
-	isolation.c lineread.c log.c mld.c ndp.c netlink.c packet.c passt.c \
-	pasta.c pcap.c siphash.c tap.c tcp.c tcp_splice.c udp.c util.c
+PASST_SRCS = arch.c arp.c checksum.c conf.c dhcp.c dhcpv6.c flow.c icmp.c \
+	igmp.c isolation.c lineread.c log.c mld.c ndp.c netlink.c packet.c \
+	passt.c pasta.c pcap.c pif.c port_fwd.c tap.c tcp.c tcp_splice.c udp.c \
+	util.c
 QRAP_SRCS = qrap.c
 SRCS = $(PASST_SRCS) $(QRAP_SRCS)
 
 MANPAGES = passt.1 pasta.1 qrap.1
 
-PASST_HEADERS = arch.h arp.h checksum.h conf.h dhcp.h dhcpv6.h icmp.h \
-	inany.h isolation.h lineread.h log.h ndp.h netlink.h packet.h passt.h \
-	pasta.h pcap.h port_fwd.h siphash.h tap.h tcp.h tcp_conn.h \
-	tcp_splice.h udp.h util.h
+PASST_HEADERS = arch.h arp.h checksum.h conf.h dhcp.h dhcpv6.h flow.h \
+	flow_table.h icmp.h inany.h isolation.h lineread.h log.h ndp.h \
+	netlink.h packet.h passt.h pasta.h pcap.h pif.h port_fwd.h siphash.h \
+	tap.h tcp.h tcp_conn.h tcp_splice.h udp.h util.h
 HEADERS = $(PASST_HEADERS) seccomp.h
 
 C := \#include <linux/tcp.h>\nstruct tcp_info x = { .tcpi_snd_wnd = 0 };
@@ -127,7 +129,7 @@
 valgrind: EXTRA_SYSCALLS += rt_sigprocmask rt_sigtimedwait rt_sigaction	\
 			    getpid gettid kill clock_gettime mmap	\
 			    munmap open unlink gettimeofday futex
-valgrind: FLAGS:=-g -O0 $(filter-out -O%,$(FLAGS))
+valgrind: FLAGS += -g -DVALGRIND
 valgrind: all
 
 .PHONY: clean
@@ -249,6 +251,12 @@
 # - bugprone-assignment-in-if-condition
 #	Dubious value over the compiler's built-in warning.  Would
 #	increase verbosity.
+#
+# - misc-include-cleaner
+#	Wants to include headers which *directly* provide the things
+#	we use.  That sounds nice, but means it will often want a OS
+#	specific header instead of a mostly standard one, such as
+#	<linux/limits.h> instead of <limits.h>.
 
 clang-tidy: $(SRCS) $(HEADERS)
 	clang-tidy -checks=*,-modernize-*,\
@@ -274,9 +282,15 @@
 	-readability-function-cognitive-complexity,\
 	-altera-struct-pack-align,\
 	-concurrency-mt-unsafe,\
-	-readability-identifier-length \
+	-readability-identifier-length,\
+	-misc-include-cleaner \
 	-config='{CheckOptions: [{key: bugprone-suspicious-string-compare.WarnOnImplicitComparison, value: "false"}]}' \
-	--warnings-as-errors=* $(SRCS) -- $(filter-out -pie,$(FLAGS) $(CFLAGS) $(CPPFLAGS))
+	--warnings-as-errors=* $(SRCS) -- $(filter-out -pie,$(FLAGS) $(CFLAGS) $(CPPFLAGS)) -DCLANG_TIDY_58992
+
+CPPCHECK_EXHAUSTIVE :=
+ifeq ($(shell cppcheck --check-level=exhaustive /dev/null > /dev/null 2>&1; echo $$?),0)
+	CPPCHECK_EXHAUSTIVE += --check-level=exhaustive
+endif
 
 SYSTEM_INCLUDES := /usr/include $(wildcard /usr/include/$(TARGET))
 ifeq ($(shell $(CC) -v 2>&1 | grep -c "gcc version"),1)
@@ -284,8 +298,9 @@
 SYSTEM_INCLUDES += /usr/lib/gcc/$(TARGET)/$(VER)/include
 endif
 cppcheck: $(SRCS) $(HEADERS)
-	cppcheck --std=c99 --error-exitcode=1 --enable=all --force	\
+	cppcheck --std=c11 --error-exitcode=1 --enable=all --force	\
 	--inconclusive --library=posix --quiet				\
+	$(CPPCHECK_EXHAUSTIVE)						\
 	$(SYSTEM_INCLUDES:%=-I%)					\
 	$(SYSTEM_INCLUDES:%=--config-exclude=%)				\
 	$(SYSTEM_INCLUDES:%=--suppress=*:%/*)				\

=== test/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# SPDX-License-Identifier: AGPL-3.0-or-later
+# SPDX-License-Identifier: GPL-2.0-or-later
 #
 # Tests makefile
 #
@@ -58,7 +58,7 @@
 LOCAL_ASSETS = mbuto.img mbuto.mem.img QEMU_EFI.fd \
 	$(DEBIAN_IMGS:%=prepared-%) $(FEDORA_IMGS:%=prepared-%) \
 	$(UBUNTU_NEW_IMGS:%=prepared-%) \
-	nsholder guest-key guest-key.pub \
+	nstool guest-key guest-key.pub \
 	$(TESTDATA_ASSETS)
 
 ASSETS = $(DOWNLOAD_ASSETS) $(LOCAL_ASSETS)
@@ -79,7 +79,7 @@
 mbuto.mem.img: passt.mem.mbuto mbuto ../passt.avx2
 	./mbuto/mbuto -p ./$< -c lz4 -f $@
 
-nsholder: nsholder.c
+nstool: nstool.c
 	$(CC) $(CFLAGS) -o $@ $^
 
 QEMU_EFI.fd:

=== debian/changelog ===
passt (0.0~git20240220.1e6f92b-1) unstable; urgency=medium

  * New upstream version 0.0~git20240220.1e6f92b:
    - pasta(1) now quits as expected once the container goes away when
      used as network back-end for buildah(1)
    - fix possible mix-up of ports for UDP outbound flows originating
      from -U outbound forwarding option

 -- Stefano Brivio <sbrivio@redhat.com>  Tue, 20 Feb 2024 11:05:49 +0100

passt (0.0~git20240216.08344da-1) unstable; urgency=medium

  * New upstream version 0.0~git20240216.08344da:
    - default gateway can now be sourced from host multipath routes as
      well
    - on failure of the inotify watch used by pasta to exit when a
      nsfs-bound namespace, fall back to a simple timed check

 -- Stefano Brivio <sbrivio@redhat.com>  Fri, 16 Feb 2024 11:02:16 +0100

passt (0.0~git20231230.f091893-1) unstable; urgency=medium

  * New upstream version 0.0~git20231230.f091893:
    - increase lifetime for router and prefix validity in router
      advertisements to maximum allowed values
    - pick most specific IPv6 global unicast address (via netlink) for
      guest configuration, if multiple addresses are available

 -- Stefano Brivio <sbrivio@redhat.com>  Tue, 02 Jan 2024 17:07:41 +0100

passt (0.0~git20231204.b86afe3-1) unstable; urgency=medium

  * New upstream version 0.0~git20231204.b86afe3
  * Fixes build warnings on 32-bit architectures due to mismatching
    format specifiers

 -- Stefano Brivio <sbrivio@redhat.com>  Mon, 04 Dec 2023 11:14:52 +0100

passt (0.0~git20231107.74e6f48-1) unstable; urgency=medium

  * New upstream version 0.0~git20231107.74e6f48
  * Most notable fixed issue: DNS resolution stopped working after a
    relatively long time, https://bugs.passt.top/show_bug.cgi?id=57
  * debian/rules: 'host' is the machine we're building for, not 'build'

 -- Stefano Brivio <sbrivio@redhat.com>  Tue, 07 Nov 2023 14:10:52 +0100

passt (0.0~git20231004.f851084-1) unstable; urgency=medium

  * New upstream version 0.0~git20231004.f851084
  * Most notable fix: workaround to trigger TCP window update in kernel
    after it was reported empty, on socket side, very visible with
    default values for rmem_max and wmem_max
    (https://bugs.passt.top/show_bug.cgi?id=74)

 -- Stefano Brivio <sbrivio@redhat.com>  Tue, 10 Oct 2023 00:13:04 +0200

passt (0.0~git20230908.05627dc-1) unstable; urgency=medium

  * debian/rules: Pass DEB_BUILD_GNU_CPU to Makefile, not DEB_BUILD_ARCH
  * debian/rules: Override pasta symbolic links with hard links
  * debian/rules: Install new pasta profile using dh_apparmor
  * New upstream version 0.0~git20230908.05627dc

 -- Stefano Brivio <sbrivio@redhat.com>  Fri, 08 Sep 2023 17:39:07 +0200

passt (0.0~git20230823.a7e4bfb-1) unstable; urgency=medium

  * New upstream version 0.0~git20230823.a7e4bfb
  * Several fixes for pasta --config-net operation, most importantly:
    don't copy lifetime information of addresses from host, avoid
    unexpected expiration of IPv4 addresses

 -- Stefano Brivio <sbrivio@redhat.com>  Wed, 23 Aug 2023 23:10:18 +0200

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_auto_install:
	dh_auto_install -- prefix=/usr TARGET=$(DEB_HOST_GNU_CPU)
	ln -f debian/passt/usr/bin/passt debian/passt/usr/bin/pasta
ifneq (,$(findstring amd64,$(DEB_HOST_ARCH)))
	ln -f debian/passt/usr/bin/passt.avx2 debian/passt/usr/bin/pasta.avx2
endif
	dh_apparmor --profile-name=usr.bin.passt -ppasst
	dh_apparmor --profile-name=usr.bin.pasta -ppasst

ifneq (,$(findstring amd64,$(DEB_HOST_ARCH)))
override_dh_link:
	dh_link usr/share/man/man1/passt.1 usr/share/man/man1/passt.avx2.1
	dh_link usr/share/man/man1/pasta.1 usr/share/man/man1/pasta.avx2.1
endif

%:
	export VERSION="$(DEB_UPSTREAM_VERSION)"
	dh $@

## passt 0.0~git20240624.1ee2eca

=== Makefile ===
--- 
+++ 
@@ -44,19 +44,20 @@
 FLAGS += -DVERSION=\"$(VERSION)\"
 FLAGS += -DDUAL_STACK_SOCKETS=$(DUAL_STACK_SOCKETS)
 
-PASST_SRCS = arch.c arp.c checksum.c conf.c dhcp.c dhcpv6.c flow.c icmp.c \
-	igmp.c isolation.c lineread.c log.c mld.c ndp.c netlink.c packet.c \
-	passt.c pasta.c pcap.c pif.c port_fwd.c tap.c tcp.c tcp_splice.c udp.c \
-	util.c
+PASST_SRCS = arch.c arp.c checksum.c conf.c dhcp.c dhcpv6.c flow.c fwd.c \
+	icmp.c igmp.c inany.c iov.c ip.c isolation.c lineread.c log.c mld.c \
+	ndp.c netlink.c packet.c passt.c pasta.c pcap.c pif.c tap.c tcp.c \
+	tcp_buf.c tcp_splice.c udp.c util.c
 QRAP_SRCS = qrap.c
 SRCS = $(PASST_SRCS) $(QRAP_SRCS)
 
 MANPAGES = passt.1 pasta.1 qrap.1
 
-PASST_HEADERS = arch.h arp.h checksum.h conf.h dhcp.h dhcpv6.h flow.h \
-	flow_table.h icmp.h inany.h isolation.h lineread.h log.h ndp.h \
-	netlink.h packet.h passt.h pasta.h pcap.h pif.h port_fwd.h siphash.h \
-	tap.h tcp.h tcp_conn.h tcp_splice.h udp.h util.h
+PASST_HEADERS = arch.h arp.h checksum.h conf.h dhcp.h dhcpv6.h flow.h fwd.h \
+	flow_table.h icmp.h icmp_flow.h inany.h iov.h ip.h isolation.h \
+	lineread.h log.h ndp.h netlink.h packet.h passt.h pasta.h pcap.h pif.h \
+	siphash.h tap.h tcp.h tcp_buf.h tcp_conn.h tcp_internal.h tcp_splice.h \
+	udp.h util.h
 HEADERS = $(PASST_HEADERS) seccomp.h
 
 C := \#include <linux/tcp.h>\nstruct tcp_info x = { .tcpi_snd_wnd = 0 };
@@ -192,7 +193,6 @@
 # - llvmlibc-restrict-system-libc-headers
 #	TODO: this is Linux-only for the moment, nice to fix eventually
 #
-# - bugprone-macro-parentheses
 # - google-readability-braces-around-statements
 # - hicpp-braces-around-statements
 # - readability-braces-around-statements
@@ -257,13 +257,18 @@
 #	we use.  That sounds nice, but means it will often want a OS
 #	specific header instead of a mostly standard one, such as
 #	<linux/limits.h> instead of <limits.h>.
+#
+# - cppcoreguidelines-macro-to-enum
+#	Want to replace all #defines of integers with enums.  Kind of
+#	makes sense when those defines form an enum-like set, but
+#	weird for cases like standalone constants, and causes other
+#	awkwardness for a bunch of cases we use
 
 clang-tidy: $(SRCS) $(HEADERS)
 	clang-tidy -checks=*,-modernize-*,\
 	-clang-analyzer-valist.Uninitialized,\
 	-cppcoreguidelines-init-variables,\
 	-bugprone-assignment-in-if-condition,\
-	-bugprone-macro-parentheses,\
 	-google-readability-braces-around-statements,\
 	-hicpp-braces-around-statements,\
 	-readability-braces-around-statements,\
@@ -283,14 +288,10 @@
 	-altera-struct-pack-align,\
 	-concurrency-mt-unsafe,\
 	-readability-identifier-length,\
-	-misc-include-cleaner \
+	-misc-include-cleaner,\
+	-cppcoreguidelines-macro-to-enum \
 	-config='{CheckOptions: [{key: bugprone-suspicious-string-compare.WarnOnImplicitComparison, value: "false"}]}' \
 	--warnings-as-errors=* $(SRCS) -- $(filter-out -pie,$(FLAGS) $(CFLAGS) $(CPPFLAGS)) -DCLANG_TIDY_58992
-
-CPPCHECK_EXHAUSTIVE :=
-ifeq ($(shell cppcheck --check-level=exhaustive /dev/null > /dev/null 2>&1; echo $$?),0)
-	CPPCHECK_EXHAUSTIVE += --check-level=exhaustive
-endif
 
 SYSTEM_INCLUDES := /usr/include $(wildcard /usr/include/$(TARGET))
 ifeq ($(shell $(CC) -v 2>&1 | grep -c "gcc version"),1)
@@ -298,9 +299,14 @@
 SYSTEM_INCLUDES += /usr/lib/gcc/$(TARGET)/$(VER)/include
 endif
 cppcheck: $(SRCS) $(HEADERS)
+	if cppcheck --check-level=exhaustive /dev/null > /dev/null 2>&1; then \
+		CPPCHECK_EXHAUSTIVE="--check-level=exhaustive";		\
+	else								\
+		CPPCHECK_EXHAUSTIVE=;					\
+	fi;								\
 	cppcheck --std=c11 --error-exitcode=1 --enable=all --force	\
 	--inconclusive --library=posix --quiet				\
-	$(CPPCHECK_EXHAUSTIVE)						\
+	$${CPPCHECK_EXHAUSTIVE}						\
 	$(SYSTEM_INCLUDES:%=-I%)					\
 	$(SYSTEM_INCLUDES:%=--config-exclude=%)				\
 	$(SYSTEM_INCLUDES:%=--suppress=*:%/*)				\
@@ -308,4 +314,4 @@
 	--inline-suppr							\
 	--suppress=unusedStructMember					\
 	$(filter -D%,$(FLAGS) $(CFLAGS) $(CPPFLAGS))			\
-	.
+	$(SRCS) $(HEADERS)

=== debian/changelog ===
passt (0.0~git20240624.1ee2eca-1) unstable; urgency=medium

  * New upstream version 0.0~git20240624.1ee2eca:
    - Outbound connections now work when ip_non_local_bind sysctls are set:
      https://github.com/containers/podman/issues/23003
    - Start even if we have multiple interfaces but no default routes:
      https://bugzilla.redhat.com/show_bug.cgi?id=2277954
    - Fix duplicating routes to containers with 'noprefixroute' addresses:
      https://github.com/containers/podman/issues/22824
    - Don't fail to duplicate routes originated from OSPF daemons:
      https://github.com/containers/podman/issues/22960
    - Always log to standard error during initialisation, and if in foreground
    - Fix UDP port forwarding with different original and target ports:
      https://bugs.passt.top/show_bug.cgi?id=80 was reintroduced and has been
      fixed again

 -- Stefano Brivio <sbrivio@redhat.com>  Mon, 24 Jun 2024 18:03:28 +0200

passt (0.0~git20240607.8a83b53-1) unstable; urgency=medium

  * New upstream version 0.0~git20240607.8a83b53, most notable fix:
    avoid triggering an assertion if container or guest try to access
    an unreachable port using the address of the default gateway
    (https://github.com/containers/podman/issues/22925)

 -- Stefano Brivio <sbrivio@redhat.com>  Fri, 07 Jun 2024 20:52:50 +0200

passt (0.0~git20240523.765eb0b-1) unstable; urgency=medium

  * New upstream version 0.0~git20240523.765eb0b

 -- Stefano Brivio <sbrivio@redhat.com>  Thu, 23 May 2024 19:48:09 +0200

passt (0.0~git20240426.d03c4e2-1) unstable; urgency=medium

  * Actually install pasta's AppArmor profile from passt.install
  * debian/control: Bump standards version from 4.6.2 to 4.7.0
  * New upstream version 0.0~git20240426.d03c4e2

 -- Stefano Brivio <sbrivio@redhat.com>  Fri, 26 Apr 2024 08:39:30 +0200

passt (0.0~git20240326.4988e2b-1) unstable; urgency=medium

  * debian/rules: Include pkg-info.mk
  * New upstream version 0.0~git20240326.4988e2b: never send TCP
    segments with none of ACK, SYN or RST flags to avoid unexpected
    connection resets (https://github.com/containers/podman/issues/22146)

 -- Stefano Brivio <sbrivio@redhat.com>  Tue, 26 Mar 2024 10:28:50 +0100

passt (0.0~git20240320.71dd405-1) unstable; urgency=medium

  * New upstream version 0.0~git20240320.71dd405, most notable fix:
    pasta(1) hang on start-up with Linux kernel versions 6.9 and later
  * debian/rules: It's DEB_VERSION_UPSTREAM, not DEB_UPSTREAM_VERSION

 -- Stefano Brivio <sbrivio@redhat.com>  Wed, 20 Mar 2024 12:14:37 +0100

## passt 0.0~git20240814.61c0b0d

=== Makefile ===
--- 
+++ 
@@ -47,7 +47,7 @@
 PASST_SRCS = arch.c arp.c checksum.c conf.c dhcp.c dhcpv6.c flow.c fwd.c \
 	icmp.c igmp.c inany.c iov.c ip.c isolation.c lineread.c log.c mld.c \
 	ndp.c netlink.c packet.c passt.c pasta.c pcap.c pif.c tap.c tcp.c \
-	tcp_buf.c tcp_splice.c udp.c util.c
+	tcp_buf.c tcp_splice.c udp.c udp_flow.c util.c
 QRAP_SRCS = qrap.c
 SRCS = $(PASST_SRCS) $(QRAP_SRCS)
 
@@ -57,7 +57,7 @@
 	flow_table.h icmp.h icmp_flow.h inany.h iov.h ip.h isolation.h \
 	lineread.h log.h ndp.h netlink.h packet.h passt.h pasta.h pcap.h pif.h \
 	siphash.h tap.h tcp.h tcp_buf.h tcp_conn.h tcp_internal.h tcp_splice.h \
-	udp.h util.h
+	udp.h udp_flow.h util.h
 HEADERS = $(PASST_HEADERS) seccomp.h
 
 C := \#include <linux/tcp.h>\nstruct tcp_info x = { .tcpi_snd_wnd = 0 };
@@ -128,7 +128,7 @@
 	$(CC) $(FLAGS) $(CFLAGS) $(CPPFLAGS) $(QRAP_SRCS) -o qrap $(LDFLAGS)
 
 valgrind: EXTRA_SYSCALLS += rt_sigprocmask rt_sigtimedwait rt_sigaction	\
-			    getpid gettid kill clock_gettime mmap	\
+			    rt_sigreturn getpid gettid kill clock_gettime mmap \
 			    munmap open unlink gettimeofday futex
 valgrind: FLAGS += -g -DVALGRIND
 valgrind: all

=== debian/changelog ===
passt (0.0~git20240814.61c0b0d-1) unstable; urgency=medium

  * New upstream version 0.0~git20240814.61c0b0d:
    - Avoid triggering an ASSERT() checking that the port isn't zero
      when the container sends a TCP packet to port zero

 -- Stefano Brivio <sbrivio@redhat.com>  Wed, 14 Aug 2024 13:54:49 +0200

passt (0.0~git20240806.ee36266-1) unstable; urgency=medium

  * New upstream version 0.0~git20240806.ee36266:
    - Fix possible TCP transfer hang on local pasta(1) connections:
      https://github.com/containers/podman/issues/23517

 -- Stefano Brivio <sbrivio@redhat.com>  Tue, 06 Aug 2024 15:46:13 +0200

passt (0.0~git20240726.57a21d2-1) unstable; urgency=medium

  * New upstream version 0.0~git20240726.57a21d2:
    - Unified flow table for all flow types (TCP, UDP, ICMP), with the side
      effect of fixing possible inconsistencies in UDP source port tracking
    - Forwarding for DNS queries over TCP and DNS over TLS (dot) now supported

 -- Stefano Brivio <sbrivio@redhat.com>  Fri, 26 Jul 2024 15:54:22 +0200
